---
title: RTCPeerConnection.addTrack()
slug: Web/API/RTCPeerConnection/addTrack
tags:
  - API
  - Audio
  - Media
  - Method
  - RTCPeerConnection
  - Reference
  - Tracks
  - Video
  - WebRTC
  - addTrack
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The {{domxref("RTCPeerConnection")}} method <strong><code>addTrack()</code></strong> adds a new media track to the set of tracks which will be transmitted to the other peer.</span></p>

<div class="note">
<p><strong>Note:</strong> Adding a track to a connection triggers renegotiation by firing a {{event("negotiationneeded")}} event. See {{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling", "Starting negotiation")}} for details.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>rtpSender</em> = <em>rtcPeerConnection</em>.addTrack(<em>track</em>, <em>stream...</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>track</code></dt>
 <dd>A {{domxref("MediaStreamTrack")}} object representing the media track to add to the peer connection.</dd>
 <dt><code>stream...</code> {{optional_inline}}</dt>
 <dd>One or more local {{domxref("MediaStream")}} objects to which the track should be added.</dd>
</dl>

<p>The specified <code>track</code> doesn't necessarily have to already be part of any of the specified <code>stream</code>s. Instead, the <code>stream</code>s are a way to group tracks together on the receiving end of the connection, making sure they are synchronized. Any tracks that are added to the same stream on the local end of the connection will be on the same stream on the remote end.</p>

<h3 id="Return_value">Return value</h3>

<p>The {{domxref("RTCRtpSender")}} object which will be used to transmit the media data.</p>

<div class="note">
<p><strong>Note:</strong> Every <code>RTCRtpSender</code> is paired with an {{domxref("RTCRtpReceiver")}} to make up an {{domxref("RTCRtpTransceiver")}}. The associated receiver is muted (indicating that it is not able to deliver packets) until and unless one or more streams are added to the receiver by the remote peer.</p>
</div>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidAccessError</code></dt>
 <dd>The specified track (or all of its underlying streams) is already part of the {{domxref("RTCPeerConnection")}}.</dd>
 <dt><code>InvalidStateError</code></dt>
 <dd>The {{domxref("RTCPeerConnection")}} is closed.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Adding_tracks_to_multiple_streams">Adding tracks to multiple streams</h3>

<p>After the <code>track</code> parameter, you can optionally specify one or more {{domxref("MediaStream")}} objects to add the track to. Only tracks are sent from one peer to another, not streams. Since streams are specific to each peer, specifying one or more streams means the other peer will create a corresponding stream (or streams) automatically on the other end of the connection, and will then automatically add the received track to those streams.</p>

<h4 id="Streamless_tracks">Streamless tracks</h4>

<p>If no streams are specified, then the track is <strong>streamless</strong>. This is perfectly acceptable, although it will be up to the remote peer to decide what stream to insert the track into, if any. This is a very common way to use <code>addTrack()</code> when building many types of simple applications, where only one stream is needed. For example, if all you're sharing with the remote peer is a single stream with an audio track and a video track, you don't need to deal with managing what track is in what stream, so you might as well just let the transceiver handle it for you.</p>

<p>Here's an example showing a function that uses {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} to obtain a stream from a user's camera and microphone, then adds each track from the stream to the peer connection, without specifying a stream for each track:</p>

<pre class="brush: js">async openCall(pc) {
  const gumStream = await navigator.mediaDevices.getUserMedia(
                          {video: true, audio: true});
  for (const track of gumStream.getTracks()) {
    pc.addTrack(track);
  }
}</pre>

<p>The result is a set of tracks being sent to the remote peer, with no stream associations. The handler for the {{event("track")}} event on the remote peer will be responsible for determining what stream to add each track to, even if that means adding them all to the same stream. The {{domxref("RTCPeerConnection.ontrack", "ontrack")}} handler might look like this:</p>

<pre class="brush: js">let inboundStream = null;

pc.ontrack = ev =&gt; {
  if (ev.streams &amp;&amp; ev.streams[0]) {
    videoElem.srcObject = ev.streams[0];
  } else {
    if (!inboundStream) {
      inboundStream = new MediaStream();
      videoElem.srcObject = inboundStream;
    }
    inboundStream.addTrack(ev.track);
  }
}</pre>

<p>Here, the <code>track</code> event handler adds the track to the first stream specified by the event, if a stream is specified. Otherwise, the first time <code>ontrack</code> is called, a new stream is created and attached to the video element, and then the track is added to the new stream. From then on, new tracks are added to that stream.</p>

<p>You could also just create a new stream for each track received:</p>

<pre class="brush: js">pc.ontrack = ev =&gt; {
  if (ev.streams &amp;&amp; ev.streams[0]) {
    videoElem.srcObject = ev.streams[0];
  } else {
    let inboundStream = new MediaStream(ev.track);
    videoElem.srcObject = inboundStream;
  }
}</pre>

<h4 id="Associating_tracks_with_specific_streams">Associating tracks with specific streams</h4>

<p>By specifying a stream and allowing {{domxref("RTCPeerConnection")}} to create streams for you, the streams' track associations are automatically managed for you by the WebRTC infrastructure. This includes things like changes to the transceiver's {{domxref("RTCRtpTransceiver.direction", "direction")}} and tracks being halted using {{domxref("RTCPeerConnection.removeTrack", "removeTrack()")}}.</p>

<p>For example, consider this function that an application might use to begin streaming a device's camera and microphone input over an {{domxref("RTCPeerConnection")}} to a remote peer:</p>

<pre class="brush: js">async openCall(pc) {
  const gumStream = await navigator.mediaDevices.getUserMedia(
                          {video: true, audio: true});
  for (const track of gumStream.getTracks()) {
    pc.addTrack(track, gumStream);
  }
}</pre>

<p>The remote peer might then use a {{event("track")}} event handler that looks like this:</p>

<pre class="brush: js">pc.ontrack = ({streams: [stream]} =&gt; videoElem.srcObject = stream;</pre>

<p>This sets the video element's current stream to the one that contains the track that's been added to the connection.</p>

<h3 id="Reused_senders">Reused senders</h3>

<p>This method may return either a new <code>RTCRtpSender</code> or, under very specific circumstances, an existing compatible sender which has not yet been used to transmit data. Compatible reusable <code>RTCRtpSender</code> instances meet these criteria:</p>

<ul>
 <li>There is no track already associated with the sender.</li>
 <li>The {{domxref("RTCRtpTransceiver")}} associated with the sender has a {{domxref("RTCRtpReceiver")}} whose {{domxref("RTCRtpReceiver.track", "track")}} property specifies a {{domxref("MediaStreamTrack")}} whose {{domxref("MediaStreamTrack.kind", "kind")}} is the same as the <code>kind</code> of the <code>track</code> parameter specified when calling <code>RTCPeerConnection.addTrack()</code>. This ensures that a transceiver only handles audio or video and never both.</li>
 <li>The <code>RTCRtpTransceiver</code>'s {{domxref("RTCRtpTransceiver.stopped", "stopped")}} property is <code>false</code>.</li>
 <li>The <code>RTCRtpSender</code> being considered has never been used to send data. If the transceiver's {{domxref("RTCRtpTransceiver.currentDirection", "currentDirection")}} has ever been <code>"sendrecv"</code> or <code>"sendonly"</code>, the sender can't be reused.</li>
</ul>

<p>If all of those criteria are met, the sender gets reused, which results in these changes occurring to the existing <code>RTCRtpSender</code> and its <code>RTCRtpTransceiver</code>:</p>

<ul>
 <li>The <code>RTCRtpSender</code>'s {{domxref("RTCRtpSender.track", "track")}} is set to the specified track.</li>
 <li>The sender's set of associated streams is set to the list of streams passed into this method, <code>stream...</code>.</li>
 <li>The associated {{domxref("RTCRtpTransceiver")}} has its <code>currentDirection</code> updated to include sending; if its current value is <code>"recvonly"</code>, it becomes <code>"sendrecv"</code>, and if its current value is <code>"inactive"</code>, it becomes <code>"sendonly"</code>.</li>
</ul>

<h3 id="New_senders">New senders</h3>

<p>If no existing sender exists that can be reused, a new one is created. This also results in the creation of the associated objects that must exist. The process of creating a new sender results in these changes:</p>

<ul>
 <li>The new <code>RTCRtpSender</code> is created with the specified <code>track</code> and set of <code>stream</code>(s).</li>
 <li>A new {{domxref("RTCRtpReceiver")}} is created with a <em>new</em> {{domxref("MediaStreamTrack")}} as its {{domxref("RTCRtpReceiver.track", "track")}} property (not the track specified as a parameter when calling <code>addTrack()</code>). This track's {{domxref("MediaStreamTrack.kind", "kind")}} is set to match the <code>kind</code> of the track provided as an input parameter.</li>
 <li>A new {{domxref("RTCRtpTransceiver")}} is created and associated with the new sender and receiver.</li>
 <li>The new transceiver's {{domxref("RTCRtpTransceiver.direction", "direction")}} is set to <code>"sendrecv"</code>.</li>
 <li>The new transceiver is added to the <code>RTCPeerConnection</code>'s set of transceivers.</li>
</ul>

<h2 id="Example">Example</h2>

<p>This example is drawn from the code presented in the article <a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a> and its corresponding sample code. It comes from the <code>handleVideoOfferMsg()</code> method there, which is called when an offer message is received from the remote peer.</p>

<pre class="brush: js">var mediaConstraints = {
  audio: true,            // We want an audio track
  video: true             // ...and we want a video track
};

var desc = new RTCSessionDescription(sdp);

pc.setRemoteDescription(desc).then(function () {
  return navigator.mediaDevices.getUserMedia(mediaConstraints);
})
.then(function(stream) {
  previewElement.srcObject = stream;

  stream.getTracks().forEach(track =&gt; pc.addTrack(track, stream));
})</pre>

<p>This code takes SDP which has been received from the remote peer and constructs a new {{domxref("RTCSessionDescription")}} to pass into {{domxref("RTCPeerConnection.setRemoteDescription", "setRemoteDescription()")}}. Once that succeeds, it uses {{domxref("MediaDevices.getUserMedia()")}} to obtain access to the local webcam and microphone.</p>

<p>If that succeeds, the resulting stream is assigned as the source for a {{HTMLElement("video")}} element which is referenced by the variable <code>previewElement</code>.</p>

<p>The final step is to begin sending the local video across the peer connection to the caller. This is done by adding each track in the stream by iterating over the list returned by {{domxref("MediaStream.getTracks()")}} and passing them to <code>addTrack()</code> along with the <code>stream</code> which they're a component of.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-addtrack', 'RTCPeerConnection.addTrack()') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.addTrack")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/API/WebRTC">WebRTC</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Intro_to_RTP">Introduction to the Real-time Transport Protocol (RTP)</a></li>
 <li>{{domxref("RTCPeerConnection.ontrack")}}</li>
 <li>{{event("track")}}</li>
</ul>
